#!/usr/bin/perl
# fix_privs.pl: repair privileges that were broken by an earlier version
# Modified from setup.pl by Andrew Suffield <asuffield@debian.org>
###

$bot_config_dir	= '/etc/blootbot';

require "$bot_config_dir/directories";
my $bot_base_dir = $bot_state_dir;

require "$bot_src_dir/core.pl";
require "$bot_src_dir/logger.pl";
require "$bot_src_dir/modules.pl";
require "$bot_src_dir/Misc.pl";
require "$bot_src_dir/interface.pl";

# read param stuff from blootbot.config.
&loadConfig("$bot_config_dir/blootbot.config");
&loadDBModules();
my $dbname = $param{'DBName'};
my $query;

if ($dbname eq "") {
  print "error: appears that the config file was not loaded properly.\n";
  exit 1;
}

if ($param{'DBType'} =~ /mysql/i) {
    use DBI;

    print "Please enter user information for root access to the mysql database.\n";
    print "The username is probably 'root', the password you should have set\n";
    print "yourself. If you haven't set one yet, leave it blank, and read\n";
    print "/usr/share/doc/mysql-server/README.Debian\n";
    # username.
    print "Username: ";
    chop (my $adminuser = <STDIN>);

    # passwd.
    system "stty -echo";
    print "Password: ";
    chop(my $adminpass = <STDIN>);
    print "\n";
    system "stty echo";

    if ($adminuser eq "" or $adminpass eq "") {
	&ERROR("error: adminuser || adminpass is NULL.");
	exit 1;
    }

    &openDB("mysql", $adminuser, $adminpass);

    &status("--- Fixing access rights for user $param{SQLUser}.");

    $query = "REVOKE ALL ON *.* FROM $param{SQLUser}\@localhost";
    &dbRaw("revoke(user)", $query);

    $query = "GRANT ALTER, CREATE, DELETE, DROP, INSERT, SELECT, UPDATE " .
             "ON $param{DBName}.* TO $param{SQLUser}\@localhost IDENTIFIED BY '$param{SQLPass}'";

    &dbRaw("create(user)", $query);

    # flush.
    &status("Flushing privileges...");
    $query = "FLUSH PRIVILEGES";
    &dbRaw("mysql(flush)", $query);
}

&status("Done.");

&closeDB();
